//Write the JavaScript code for your panel here.
var httpRequest = false;


SetTimer("refresh", 1, null);

function makeRequest(url)
{
  httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
  if (!httpRequest)
  {
    sidebar.MsgBox("Cannot initialize XMLHTTP object. Please make sure you have the latest version of MSXML installed.", "Panel Error", 0);
    return;
  }
  httpRequest.onReadyStateChange = stateChange;
  httpRequest.open("GET", url, true);
  httpRequest.send(null);
}

function stateChange()
{
  if(httpRequest.readyState == 4)
  {
     if (httpRequest.status == 200)
     {
     	var host = config.GetSetting("nagioshost1");
     	GetControl("nagios1").setText(host);
     	//sidebar.MsgBox("Downloaded text:\n" + httpRequest.responseText, "Success", 0);
     	var crit = "udefined";
     	var warn = "udefined";
     	var unknown = "udefined";
     	var ok = "udefined";
     	crit = extractTagValue(httpRequest.responseText, "servicestatustypes=16' class='serviceHeader'>", "Critical");
     	warn = extractTagValue(httpRequest.responseText, "servicestatustypes=4' class='serviceHeader'>", "Warning");
     	unknown = extractTagValue(httpRequest.responseText, "servicestatustypes=8' class='serviceHeader'>", "Unknown");
     	ok = extractTagValue(httpRequest.responseText, "servicestatustypes=2' class='serviceHeader'>", "Ok");
     	GetControl("nagioscrit1").setText(crit);
     	GetControl("nagioswarn1").setText(warn);
     	GetControl("nagiosunknown1").setText(unknown);
     	GetControl("nagiosok1").setText(ok);
      } 
      else 
      {
        GetControl("nagios1").setText("Request on host failed!");
      }
  }
}

function extractTagValue(xml, tag, tag2) {
    var start = xml.indexOf(tag) + tag.length;  // starting position of the value
    if (start < 0) {
        return null;
    }
    var end = xml.indexOf(tag2);  // ending position of the value (+1)
    return xml.substring(start, end + tag2.length);
}
function refresh()
{
	StopTimer();
	var naguser1 = config.GetSetting("nagiosuser1");
	var nagpw1 = config.GetSetting("nagiospw1");
	var nagcgi1 = config.GetSetting("nagioscgi1");
	var naghost1 = config.GetSetting("nagioshost1");
	var url1 = "http://"+naguser1+":"+nagpw1+"@"+naghost1+"/"+nagcgi1+"/tac.cgi";
	makeRequest(url1);
	SetTimer("refresh", config.GetSetting("nagiosrefresh1"), null);
}

function onClick1()
{
    //sidebar.MsgBox("Test","Test",0);
    var WshShell = new ActiveXObject("WScript.Shell");
	var nagbase1 = config.GetSetting("nagiosbase1");
	var naghost1 = config.GetSetting("nagioshost1");
	var url1 = "http://"+naghost1+"/"+nagbase1;
    WshShell.Run(url1);
}

function onShowDetails1()
{
    //var cf=sidebar.GetControlFactory();
    
    httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
  		if (!httpRequest)
		{
			sidebar.MsgBox("Cannot initialize XMLHTTP object. Please make sure you have the latest version of MSXML installed.", "Panel Error", 0);
			return;
		}
		var naguser1 = config.GetSetting("nagiosuser1");
		var nagpw1 = config.GetSetting("nagiospw1");
		var nagcgi1 = config.GetSetting("nagioscgi1");
		var naghost1 = config.GetSetting("nagioshost1");
		var url = "http://"+naguser1+":"+nagpw1+"@"+naghost1+"/"+nagcgi1+"/"+"status.cgi?host=all&servicestatustypes=28";
		httpRequest.onReadyStateChange = stateChangeDetail;
		httpRequest.open("GET", url, true);
		httpRequest.send(null);
    
}

function stateChangeDetail()
{
  if(httpRequest.readyState == 4)
  {
     if (httpRequest.status == 200)
     {
     	var details = sidebar.GetControlFactory().CreateHTMLDetailsWnd2("nagiosCheckerProd",false, 0);
		details.Create2(canvas.GetHwnd(), config);
    	details.SetCaption("Preview of NagiosAlarms");
    	var host = "";
    	var service = "";
    	var level = "";
    	var start = 1;
    	var end = 2;
    	var html = httpRequest.responseText;
    	var crits = "";
    	var warns = "";
    	var unks = "";
    	var host = "";
    	var crittag = "<TD ALIGN=LEFT valign=center CLASS='statusBGCRITICAL'><A HREF='extinfo.cgi?type=2&host=";
    	var warntag = "<TD ALIGN=LEFT valign=center CLASS='statusBGWARNING'><A HREF='extinfo.cgi?type=2&host=";
    	var unktag = "<TD ALIGN=LEFT valign=center CLASS='statusBGUNKNOWN'><A HREF='extinfo.cgi?type=2&host=";
    	for (var i=1;i<5;i++)
    	{
    		if (html.indexOf(crittag,start) != -1){
    			start = html.indexOf(crittag,start) + crittag.length;
    			end = html.indexOf("&service",start);
    			host = html.substring(start, end);
    			start = html.indexOf("'>",end) + 2;
    			end = html.indexOf("</A>",start);
    			crits = crits + host + ": " + html.substring(start, end) + "<br/>";
    		}
    		
    	}
    	start = 1;
    	end = 2;
    	for (var i=1;i<5;i++)
    	{
    		if (html.indexOf(warntag,start) != -1){
    			start = html.indexOf(warntag,start) + warntag.length;
    			end = html.indexOf("&service",start);
    			host = html.substring(start, end);
    			start = html.indexOf("'>",end) + 2;
    			end = html.indexOf("</A>",start);
    			warns = warns + host + ": " + html.substring(start, end) + "<br/>";
    		}
    		
    	}
    	start = 1;
    	end = 2;
    	for (var i=1;i<5;i++)
    	{
    		if (html.indexOf(unktag,start) != -1){
    			start = html.indexOf(unktag,start) + unktag.length;
    			end = html.indexOf("&service",start);
    			host = html.substring(start, end);
    			start = html.indexOf("'>",end) + 2;
    			end = html.indexOf("</A>",start);
    			unks = unks + host + ": " + html.substring(start, end) + "<br/>";
    		}
    		
    	}
    	details.Set("CRITICALS:<br/>" + crits + "<br/>" + "WARNINGS:<br/>" + warns + "<br/>" + "UNKNOWNS:<br/>" + unks);
    	
      } 
      else 
      {
        var details = sidebar.GetControlFactory().CreateHTMLDetailsWnd2("nagiosCheckerProd",false, 0);
		details.Create2(canvas.GetHwnd(), config);
    	details.SetCaption("Preview of NagiosAlarms");
    	details.Set("Request on host failed!");
      }
  }
}
